using System;
using System.Collections;
using UnityEngine;
using System.Linq;
using System.Collections.Generic;
using System.IO;


namespace Mod
{
    public class Mod : MonoBehaviour
    {
        /// My sanity is rapidly decreasing.
        /// It's like an negative exponential curve.
        public static Sprite gravel = ModAPI.LoadSprite("GravelFull.png");
        public static float resizemultiplier = 1f;
        public static Sprite sand = ModAPI.LoadSprite("SandDraw.png");
        public static Sprite dirt = ModAPI.LoadSprite("Dirt.png");
        public static Sprite grass = ModAPI.LoadSprite("Grass.png");
        public static Sprite flesh = ModAPI.LoadSprite("Flesh.png");
        public static Sprite spike = ModAPI.LoadSprite("Spike.png");
        public static Sprite water = ModAPI.LoadSprite("Water.png");
        public static Sprite wood = ModAPI.LoadSprite("Wood.png");
        public static Sprite stone = ModAPI.LoadSprite("Stone.png");
        public static Sprite tile = ModAPI.LoadSprite("Tiles.png");
        public static Sprite bounce = ModAPI.LoadSprite("Bounce.png");
        public static Sprite accel = ModAPI.LoadSprite("Accel.png");
        public static Sprite brick = ModAPI.LoadSprite("Brick.png");
        public static Sprite iceunder = ModAPI.LoadSprite("iceunder.png");
        /// Backgrounds
        public static Sprite cloud = ModAPI.LoadSprite("Cloud.png");
        public static Sprite sky = ModAPI.LoadSprite("Sky.png");
        public static Sprite sky2 = ModAPI.LoadSprite("NightSky.png");
        public static Sprite sky3 = ModAPI.LoadSprite("GreenScreen.png");
        public static Sprite gravelbg = ModAPI.LoadSprite("Gravelbackground.png");
        public static Sprite sandbg = ModAPI.LoadSprite("Sandbackground.png");
        public static Sprite dirtbg = ModAPI.LoadSprite("Dirtbackground.png");
        public static Sprite grassbg = ModAPI.LoadSprite("Grassbackground.png");
        public static Sprite fleshbg = ModAPI.LoadSprite("Fleshbackground.png");
        public static Sprite cloudbg = ModAPI.LoadSprite("Cloudbackground.png");
        public static Sprite waterbg = ModAPI.LoadSprite("Waterbackground.png");
        public static Sprite woodbg = ModAPI.LoadSprite("Woodbackground.png");
        public static Sprite stonebg = ModAPI.LoadSprite("Stonebackground.png");
        public static Sprite brickbg = ModAPI.LoadSprite("Brickbackground.png");
        public static Sprite iceunderbg = ModAPI.LoadSprite("iceunderbackground.png");

        public static void Main()
        {
            /// Draws
            ModAPI.RegisterPower<GrassDraw>("Grass", "Grass. Nice soft and fluffy for soft landings. It doesn't do that.", ModAPI.LoadSprite("Grass.png"));
            ModAPI.RegisterPower<GravelDraw2>("Gravel", "Draws Gravel. It looks a little bit like rocks. Originates from Gravel, Sand and Water.", ModAPI.LoadSprite("GravelFull.png"), "Grass");
            ModAPI.RegisterPower<SandDraw>("Sand", "Draws Sand. Rises from the ground only to go back under. Originates from Gravel, Sand and Water.", ModAPI.LoadSprite("SandDraw.png"), "Grass");
            ModAPI.RegisterPower<DirtDraw>("Dirt", "Dirt! You can't eat it, however.", ModAPI.LoadSprite("Dirt.png"), "Grass");
            ModAPI.RegisterPower<WoodDraw>("Wood", "Common material to frame a house with.", ModAPI.LoadSprite("Wood.png"), "Grass");
            ModAPI.RegisterPower<FleshDraw>("Flesh", "It's literally flesh.", ModAPI.LoadSprite("Flesh.png"), "Grass");
            ModAPI.RegisterPower<BounceDraw>("Bouncy Substance", "A weird mixture of unknown substances. Objects bounce off with 2x the speed put in.", ModAPI.LoadSprite("Bounce.png"), "Grass");
            ModAPI.RegisterPower<AccelDraw>("Acceleration Substance", "Looks very similar to the pink slime block in Terraria, however doesn't have the same functions. Objects accelerate infinitely.", ModAPI.LoadSprite("Accel.png"), "Grass");
            ModAPI.RegisterPower<BrickDraw>("Bricks", "Bricks. Used as the outer layer of house construction. Also used to knock people unconscious.", ModAPI.LoadSprite("Brick.png"), "Grass");
            ModAPI.RegisterPower<IceDraw>("Ice", "Slippery ice! This ice has anti-friction, letting any object slide forever!", ModAPI.LoadSprite("Water.png"), "Grass");
            ModAPI.RegisterPower<IceDrawUnder>("Packed Ice", "It's actually just a tile used to draw the bottom of ice. I didn't know what to call it.", ModAPI.LoadSprite("iceunder.png"), "Grass");
            ModAPI.RegisterPower<TilesDraw>("Black Tile", "Trademarked by Black Tiles Inc.", ModAPI.LoadSprite("Tiles.png"), "Grass");
            ModAPI.RegisterPower<StoneDraw>("Stone", "Can be mined using a wooden pickaxe. (No it can't.)", ModAPI.LoadSprite("Stone.png"), "Grass");
            ModAPI.RegisterPower<SpikeDraw>("Spikes", "These spikes don't puncture skin. They do, however, cause pain in any human that touches them.", ModAPI.LoadSprite("Spike.png"), "Grass");
            /// Backgrounds
            ModAPI.RegisterPower<GrassDrawBack>("(Background) Grass", "Grass. Nice soft and fluffy for soft landings. This time you can't even collide with it.", ModAPI.LoadSprite("Grassbackground.png"));
            ModAPI.RegisterPower<CloudDraw>("(Background) Cloud", "That shit that floats in the sky. How it do that tho?", ModAPI.LoadSprite("Cloud.png"), "(Background) Grass");
            ModAPI.RegisterPower<GravelDrawBack>("(Background) Gravel", "Gravel. Mixture of small pebbles and other stuff. Originates from Gravel, Sand and Water.", ModAPI.LoadSprite("Gravelbackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<SandDrawBack>("(Background) Sand", "Sand. Looks more like sandstone. Originates from Gravel, Sand and Water.", ModAPI.LoadSprite("Sandbackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<DirtDrawBack>("(Background) Dirt", "Dirt! You can't even try to eat this.", ModAPI.LoadSprite("Dirtbackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<WoodDrawBack>("(Background) Wood", "Not actually flammable. That would require a PhysicalBehaviour.", ModAPI.LoadSprite("Woodbackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<FleshDrawBack>("(Background) Flesh", "It's still literally flesh.", ModAPI.LoadSprite("Fleshbackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<StoneDrawBack>("(Background) Stone", "Literally not able to be mined. It's in the background.", ModAPI.LoadSprite("Stonebackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<IceTopDrawBack>("(Background) Ice", "Slippery ice! Literally doesn't make anything slip for obvious reasons.", ModAPI.LoadSprite("Waterbackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<IceDrawBack>("(Background) Packed Ice", "Still the tile for drawing underneath the Ice, but in the background.", ModAPI.LoadSprite("iceunderbackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<BrickDrawBack>("(Background) Bricks", "Bricks. Used as the outer layer of house construction. You're obviously not using it for that.", ModAPI.LoadSprite("Brickbackground.png"), "(Background) Grass");
            ModAPI.RegisterPower<SkyDraw>("(Background) Sky", "Used to draw a nice blue water reflected atmosphere. Goes great with clouds and the sun. Also draws 'slightly' larger.", ModAPI.LoadSprite("Sky.png"), "(Background) Grass");
            ModAPI.RegisterPower<Sky2Draw>("(Background) Night Sky", "Without a sun, the sky becomes a dark shade. You can still spawn a sun, but whatever. Also draws 'slightly' larger.", ModAPI.LoadSprite("NightSky.png"), "(Background) Grass");
            ModAPI.RegisterPower<Sky3Draw>("(Background) Green Screen", "For editing purposes and other stuff. Also draws much larger. (USE WITH TONE MAPPING OFF)", ModAPI.LoadSprite("GreenScreen.png"), "(Background) Grass");
            /// Objects
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Brick"),
                NameOverride = "Sun",
                NameToOrderByOverride = "Sun",
                DescriptionOverride = "Hydrogen Gas Ball.",
                CategoryOverride = ModAPI.FindCategory("Misc."),
                ThumbnailOverride = ModAPI.LoadSprite("Sun.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sun.png");
                    Instance.GetComponent<SpriteRenderer>().color = new Color(0.3f, 0.4f, 0.5f, 1f);
                    Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                    Instance.layer = 11;
                    Instance.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
                    GameObject.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.GetComponent<SpriteRenderer>().sortingOrder = -25;
                    var light = ModAPI.CreateLight(Instance.transform, new Color32(255, 131, 48, 255), 20, 7);
                    light.transform.localPosition = new Vector3(0, 0);
                    Instance.AddComponent<DetachBehaviour>();
                    Instance.AddComponent<SunBurn>();
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5970000000000000000000000f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5970000000000000000000000f;
                    Instance.GetComponent<Rigidbody2D>().mass = 5970000000000000000000000f;
                    Instance.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static;
                }
            }
          );

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Wooden Pole"),
                NameOverride = "Tree",
                NameToOrderByOverride = "Sun3",
                DescriptionOverride = "Trees are vital for the life of humans. Just being near one slowly makes humans feel better! Just don't get hit by a falling tree. (Warning: Side effects may include, and not limited to; Nausea, Accelerated cel mitosis, Reviving the dead, Major diarrhea.)",
                CategoryOverride = ModAPI.FindCategory("Misc."),
                ThumbnailOverride = ModAPI.LoadSprite("Tree.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Tree.png");
                    Instance.layer = 9;
                    Instance.GetComponent<Renderer>().sortingOrder = 10;
                    Instance.transform.localScale = new Vector2(3f,3.5f);
                    foreach (var col in Instance.GetComponents<Collider2D>())
                    {
                        GameObject.Destroy(col);
                    }
                    Instance.AddComponent<BoxCollider2D>();
                    Instance.AddComponent<TreeHeal>();
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 75f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 75f;
                    Instance.GetComponent<Rigidbody2D>().mass = 75f;
                }
            }
          );

            ModAPI.Register(
           new Modification()
           {
               OriginalItem = ModAPI.FindSpawnable("Wooden Chair"),
               NameOverride = "Bush",
               NameToOrderByOverride = "Sun4",
               DescriptionOverride = "This bush doesn't grow any berries. They also aren't collidable. You can toggle the collision via the context menu.",
               CategoryOverride = ModAPI.FindCategory("Misc."),
               ThumbnailOverride = ModAPI.LoadSprite("Bush.png"),
               AfterSpawn = (Instance) =>
               {
                   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Bush.png");
                   Instance.layer = 10;
                   Instance.GetComponent<Renderer>().sortingOrder = 15;
                   foreach (var col in Instance.GetComponents<Collider2D>())
                   {
                       GameObject.Destroy(col);
                   }
                   Instance.AddComponent<BoxCollider2D>();
                   Instance.GetComponent<PhysicalBehaviour>().InitialMass = 2f;
                   Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 2f;
                   Instance.GetComponent<Rigidbody2D>().mass = 2f;
                   Instance.GetComponent<Rigidbody2D>().gravityScale = 0.7f;
               }
           }
         );

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Brick"),
                NameOverride = "Moon",
                NameToOrderByOverride = "Sun2",
                DescriptionOverride = "It's the moon. Slightly emits light.",
                CategoryOverride = ModAPI.FindCategory("Misc."),
                ThumbnailOverride = ModAPI.LoadSprite("Moon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Moon.png");
                    Instance.GetComponent<SpriteRenderer>().color = new Color(255f, 255f, 255f, 1f);
                    Instance.transform.localScale = new Vector2(0.75f, 0.75f);
                    ///Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                    Instance.layer = 11;
                    Instance.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
                    GameObject.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.GetComponent<SpriteRenderer>().sortingOrder = -25;
                    var light = ModAPI.CreateLight(Instance.transform, new Color32(255, 255, 255, 255), 12, 5);
                    light.transform.localPosition = new Vector3(0, 0);
                    Instance.AddComponent<DetachBehaviour>();
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 73476730900000000000000f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 73476730900000000000000f; 
                    Instance.GetComponent<Rigidbody2D>().mass = 73476730900000000000000f;
                    Instance.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static;
                }
            }
          );
        }
    }

    class DetachBehaviour : MonoBehaviour
    {
        private bool debounce = false;
        void Update()
        {
            if (Input.GetKeyDown(KeyCode.Slash))
            {
                if (debounce == false)
                {
                    debounce = true;
                    this.gameObject.AddComponent<CircleCollider2D>();
                    this.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Dynamic;
                    this.gameObject.layer = 9;
                    this.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(0f, 2f);
                    this.gameObject.GetComponent<AudioSource>().PlayOneShot(ModAPI.LoadSound("pop.wav"), 1f);
                    this.gameObject.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Objects");
                }
            }
        }
    }

    class SunBurn : MonoBehaviour
    {
        void OnCollisionEnter2D(Collision2D col)
        {
            PhysicalBehaviour physicalBehaviour;
            foreach (PhysicalBehaviour stuff in col.gameObject.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
            {
                if (Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(stuff.gameObject.transform, out physicalBehaviour))
                {
                    physicalBehaviour.Ignite(true);
                    if (physicalBehaviour.OnFire)
                    {
                        physicalBehaviour.burnIntensity = 500000f;
                        physicalBehaviour.Properties.Burnrate = 2f;
                    }
                }
            }
        }
    }

    class TreeHeal : MonoBehaviour
    {
        private int count = 0;

        void Update()
        {
            count++;
            if (count % 250 == 0)
            {
                Collider2D[] hitColliders = Physics2D.OverlapCircleAll(this.gameObject.transform.position, 10f, 1 << 9);
                for (var i = 0; i < hitColliders.Length; i++)
                {
                    if (hitColliders[i].gameObject.GetComponent<LimbBehaviour>())
                    {
                        Heal(hitColliders[i].GetComponent<LimbBehaviour>());
                    }
                }
            }
        }

        private IEnumerator HealRottenFlesh(LimbBehaviour limb)
        {
            while (limb.SkinMaterialHandler.RottenProgress > 0.1f)
            {
                limb.SkinMaterialHandler.RottenProgress -= Time.deltaTime * 0.3f;
                yield return new WaitForEndOfFrame();
            }
            limb.SkinMaterialHandler.RottenProgress = 0f;
            yield break;
        }

        private IEnumerator HealWounds(LimbBehaviour limb)
        {
            for (;;)
            {
                if (limb.SkinMaterialHandler.damagePoints.Min((Vector4 c) => c.z) >= 50f)
                {
                    break;
                }
                for (int i = 0; i < limb.SkinMaterialHandler.damagePoints.Length; i++)
                {
                    Vector4[] damagePoints = limb.SkinMaterialHandler.damagePoints;
                    int num = i;
                    damagePoints[num].z = damagePoints[num].z + Time.deltaTime * 0.1f;
                }
                limb.SkinMaterialHandler.Sync();
                yield return new WaitForEndOfFrame();
            }
            yield break;
        }

        private IEnumerator HealBulletHoles(LimbBehaviour limb)
        {
            for (;;)
            {
                if (limb.SkinMaterialHandler.bulletHolePoints.Min((Vector4 c) => c.z) >= 50f)
                {
                    break;
                }
                for (int i = 0; i < limb.SkinMaterialHandler.bulletHolePoints.Length; i++)
                {
                    limb.SkinMaterialHandler.bulletHolePoints[i].z = Mathf.Max(limb.SkinMaterialHandler.bulletHolePoints[i].z, 0.05f);
                    Vector4[] bulletHolePoints = limb.SkinMaterialHandler.bulletHolePoints;
                    int num = i;
                    bulletHolePoints[num].z = bulletHolePoints[num].z + Time.deltaTime * 0.3f;
                }
                limb.SkinMaterialHandler.Sync();
                yield return new WaitForEndOfFrame();
            }
            yield break;
        }

        public void Heal(LimbBehaviour Limb)
        {
            Debug.Log("Attempting To Heal.");   
            if (Limb.Health < Limb.InitialHealth)
            {
                Limb.Health = Limb.Health + 2f;
            }
            this.StartCoroutine(this.HealRottenFlesh(Limb));
            this.StartCoroutine(this.HealWounds(Limb));
            this.StartCoroutine(this.HealBulletHoles(Limb));
            Limb.CirculationBehaviour.IsPump = Limb.CirculationBehaviour.WasInitiallyPumping;
            if (Limb.CirculationBehaviour.BloodFlow < 1f)
            {
                Limb.CirculationBehaviour.BloodFlow = Limb.CirculationBehaviour.BloodFlow + 0.1f;
                Limb.CirculationBehaviour.AddLiquid(Limb.GetOriginalBloodType(), 0.1f);
            }
            if (Limb.BruiseCount > 0)
            {
                Limb.BruiseCount = (ushort)(Limb.BruiseCount - 1);
            }
            if (Limb.CirculationBehaviour.GunshotWoundCount > 0)
            {
                Limb.CirculationBehaviour.GunshotWoundCount = (ushort)(Limb.CirculationBehaviour.GunshotWoundCount - 1);
            }
            if (Limb.CirculationBehaviour.StabWoundCount > 0)
            {
                Limb.CirculationBehaviour.StabWoundCount = (ushort)(Limb.CirculationBehaviour.StabWoundCount - 1);
            }
            if (Limb.CirculationBehaviour.BleedingPointCount > 0)
            {
                Limb.CirculationBehaviour.BleedingPointCount = (byte)(Limb.CirculationBehaviour.BleedingPointCount - 1);
            }
            if (Limb.CirculationBehaviour.BleedingPointCount < 3)
            {
                foreach (GameObject obj in Limb.CirculationBehaviour.BleedingParticles)
                {
                    UnityEngine.Object.Destroy(obj);
                }
                Limb.CirculationBehaviour.BleedingParticles.Clear();
            }
            if (Limb.CirculationBehaviour.BleedingRate > 0)
            {
                Limb.CirculationBehaviour.BleedingRate = Limb.CirculationBehaviour.BleedingRate - 0.1f;
            }
            if (Limb.RoughClassification == LimbBehaviour.BodyPart.Head)
            {
                if (Limb.Person.Consciousness < 1f)
                {
                    Limb.Person.Consciousness = Limb.Person.Consciousness + 0.1f;
                }
                if (Limb.Person.PainLevel > 0)
                {
                    Limb.Person.PainLevel = Limb.Person.PainLevel - 0.1f;
                }
            }
        }
    }


    /// All of the code for the drawables. Mostly copy and pasted. Should've made it into a function. Don't make the same mistake.
    class GravelDraw2 : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;
        

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.gravel;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            line.widthMultiplier = 1f;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class SkyDraw : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce = false;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;
        private MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (debounce == false && mapconfig.Settings.Rain == true)
            {
                debounce = true;
                GameObject[] bruh = UnityEngine.Object.FindObjectsOfType<GameObject>() as GameObject[];
                foreach (GameObject skytiles in bruh)
                {
                    if (skytiles.name == "Sky")
                    {
                        skytiles.GetComponent<LineRenderer>().endColor = new Color32(5, 2, 5, 255);
                        skytiles.GetComponent<LineRenderer>().startColor = new Color32(5, 2, 5, 255);
                    }
                }
            }
            if (debounce == true && mapconfig.Settings.Rain == false)
            {
                debounce = false;
                GameObject[] bruh = UnityEngine.Object.FindObjectsOfType<GameObject>() as GameObject[];
                foreach (GameObject skytiles in bruh)
                {
                    if (skytiles.name == "Sky")
                    {
                        skytiles.GetComponent<LineRenderer>().endColor = new Color32(255, 255, 255, 255);
                        skytiles.GetComponent<LineRenderer>().startColor = new Color32(255, 255, 255, 255);
                    }
                }
            }
        }

        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.sky;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 11;
            line = currentline.AddComponent<LineRenderer>();
            currentline.name = "Sky";
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 5f;
            line.endWidth = 5f;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            line.sortingOrder = -201;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 5f;
            line.endWidth = 5f;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = -101;
        }
    }

    class Sky2Draw : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce = false;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
        }

        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.sky2;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 11;
            line = currentline.AddComponent<LineRenderer>();
            currentline.name = "Sky2";
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 5f;
            line.endWidth = 5f;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 5f;
            line.endWidth = 5f;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = -101;
            /// Soon, I'll add stars to this background tile.
        }
    }

    class Sky3Draw : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce = false;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                Draw();
            }
            if (Input.GetMouseButton(0) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    UpdateLine(temppos);
                }
            }
        }

        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.sky3;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 11;
            line = currentline.AddComponent<LineRenderer>();
            currentline.name = "GreenScreen";
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 10f;
            line.endWidth = 10f;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 5f;
            line.endWidth = 5f;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = -101;
        }
    }

    class BrickDraw : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                Draw();
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    UpdateLine(temppos);
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.brick;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class BrickDrawBack : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.brickbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class WoodDrawBack : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.woodbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class IceDrawBack : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.iceunderbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class StoneDrawBack : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.stonebg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class DirtDrawBack : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.dirtbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class SandDrawBack : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.sandbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class GravelDrawBack : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.gravelbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class FleshDrawBack : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.fleshbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class IceTopDrawBack : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.waterbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class GrassDrawBack : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public int integ;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.grassbg;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = -101;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class DirtDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.dirt;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class IceDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                Draw();
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    UpdateLine(temppos);
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.water;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            var phys = new PhysicsMaterial2D();

            phys.friction = -0.5f;
            phys.bounciness = -5000f;
            collide = currentline.AddComponent<EdgeCollider2D>();
            collide.sharedMaterial = phys;
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class IceDrawUnder : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                Draw();
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    UpdateLine(temppos);
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.iceunder;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            var phys = new PhysicsMaterial2D();

            phys.friction = -0.5f;
            phys.bounciness = -5000f;
            collide = currentline.AddComponent<EdgeCollider2D>();
            collide.sharedMaterial = phys;
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class AccelDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public EdgeCollider2D trig;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.accel;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            var phys = new PhysicsMaterial2D();

            phys.friction = 0f;
            phys.bounciness = 0.25f;
            collide = currentline.AddComponent<EdgeCollider2D>();
            trig = currentline.AddComponent<EdgeCollider2D>();
            trig.isTrigger = true;
            collide.sharedMaterial = phys;
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            currentline.AddComponent<AccelStuffFast>();
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]); 
            collide.points = mousepos.ToArray();
            trig.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
            trig.points = mousepos.ToArray();
        }
    }

   /// MonoBehaviours for the acceleration substance. 

    public class AccelStuff : MonoBehaviour ///this one is an old version of the better one below.
    {
        private float dragnum;
        
        void OnTriggerStay2D(Collider2D col) 
        {
            if (col.gameObject.transform.root.gameObject.GetComponentInChildren<Rigidbody2D>())
            {
                var stuff = col.gameObject.transform.root.gameObject.GetComponentsInChildren<Rigidbody2D>();
                foreach(Rigidbody2D bruh in stuff)
                {
                    Vector2 vector = new Vector2(1, 1);
                    bruh.velocity += ((bruh.velocity + vector) + bruh.velocity.normalized) * Time.deltaTime / 5;
                    dragnum = bruh.drag;
                    bruh.drag = -0.05f;
                }
            }
        }

        void OnTriggerExit2D(Collider2D col)
        {
            if (col.gameObject.transform.root.gameObject.GetComponentInChildren<Rigidbody2D>())
            {
                var stuff = col.gameObject.transform.root.gameObject.GetComponentsInChildren<Rigidbody2D>();
                foreach (Rigidbody2D bruh in stuff)
                {
                    bruh.drag = dragnum;
                }
            }
        }
    }


    public class AccelStuffFast : MonoBehaviour ///The one I'm using.
    {
        private float dragnum;

        void OnTriggerStay2D(Collider2D col) /// This here is pretty freaking stupid. Sadly, I mostly have to use it.
        {
            if (col.gameObject.transform.root.gameObject.GetComponentInChildren<Rigidbody2D>())
            {
                var stuff = col.gameObject.transform.root.gameObject.GetComponentsInChildren<Rigidbody2D>();
                foreach (Rigidbody2D bruh in stuff)
                {
                    Vector2 vector = new Vector2(1, 1);
                    bruh.velocity += (((bruh.velocity + vector) + bruh.velocity.normalized)* Mod.resizemultiplier) * Time.deltaTime / 7f;
                    dragnum = bruh.drag;
                    bruh.drag = -0.05f;
                }
            }
        }

        void OnTriggerExit2D(Collider2D col)
        {
            if (col.gameObject.transform.root.gameObject.GetComponentInChildren<Rigidbody2D>())
            {
                var stuff = col.gameObject.transform.root.gameObject.GetComponentsInChildren<Rigidbody2D>();
                foreach (Rigidbody2D bruh in stuff)
                {
                    bruh.drag = dragnum;
                }
            }
        }
    }

    /// Humans don't like to bounce. Their multiple rigidbody's with different weights makes it hard for the bouncy physics material to do it's stuff.

    class BounceDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.bounce;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            var phys = new PhysicsMaterial2D();

            phys.friction = 0.3f;
            phys.bounciness = 2f * Mod.resizemultiplier;
            collide = currentline.AddComponent<EdgeCollider2D>();
            collide.sharedMaterial = phys;
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class GrassDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.grass;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class SandDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.sand;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class StoneDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.stone;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class CloudDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (UnityEngine.Object.FindObjectOfType<MapConfig>().Settings.Rain == true && debounce == false)
            {
                debounce = true;
                GameObject[] bruh = UnityEngine.Object.FindObjectsOfType<GameObject>() as GameObject[];
                foreach (GameObject skytiles in bruh)
                {
                    if (skytiles.name == "Cloud")
                    {
                        skytiles.GetComponent<LineRenderer>().endColor = new Color32(20, 20, 20, 255);
                        skytiles.GetComponent<LineRenderer>().startColor = new Color32(20, 20, 20, 255);
                    }
                }
            }
            if (UnityEngine.Object.FindObjectOfType<MapConfig>().Settings.Rain == false && debounce == true)
            {
                debounce = false;
                GameObject[] bruh = UnityEngine.Object.FindObjectsOfType<GameObject>() as GameObject[];
                foreach (GameObject skytiles in bruh)
                {
                    if (skytiles.name == "Cloud")
                    {
                        skytiles.GetComponent<LineRenderer>().endColor = new Color32(255, 255, 255, 255);
                        skytiles.GetComponent<LineRenderer>().startColor = new Color32(255, 255, 255, 255);
                    }
                }
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.cloud;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 10;
            currentline.name = "Cloud";
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            line.sortingOrder = -50;
            currentline.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Background");
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
        }
    }

    class FleshDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.flesh;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class TilesDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.tile;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class WoodDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.wood;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
        }
    }

    class SpikeDraw : AOEPowerTool
    {
        private float resizemultiplier = 1f;
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            ///StartCoroutine(SpawnGravelPiece());
        }

        public override float Radius
        {
            get
            {
                return 1f;
            }
        }

        public List<Vector2> mousepos;
        public List<Vector2> collidingstuff;
        public List<Vector2> somegarbage;

        private bool isHeld = false;

        public override void OnToolChosen()
        {
            this.isHeld = true;
        }

        public override void OnToolUnchosen()
        {
            this.isHeld = false;
        }

        public bool debounce;
        private bool spritestuff = true;
        private bool sometypeofdebounce = false;

        public void Awake()
        {
            mousepos = new List<Vector2>();
            collidingstuff = new List<Vector2>();
            somegarbage = new List<Vector2>();
        }

        public void Update()
        {
            if (Input.GetMouseButtonDown(0) && isHeld == true)
            {
                
                Draw();
                
            }
            if (Input.GetMouseButton(0) && isHeld == true && debounce == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                
                if (Vector2.Distance(temppos, mousepos[mousepos.Count - 1]) > 0.1f)
                {
                    
                    UpdateLine(temppos);
                    
                }
            }
            if (Input.GetKeyDown(KeyCode.P) && isHeld == true)
            {
                Vector2 temppos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                UpdateLine(temppos);
            }
            if (Input.GetKeyDown(KeyCode.K) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier + 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
            if (Input.GetKeyDown(KeyCode.L) && isHeld == true)
            {
                Mod.resizemultiplier = Mod.resizemultiplier - 0.25f;
                NotificationControllerBehaviour.Show("Size Multiplier: " + Mod.resizemultiplier);
            }
        }


        public override float DampeningRadius
        {
            get
            {
                return 0f;
            }
        }

        public float gravelweight = 0.0618f;

        public GameObject currentline;
        public LineRenderer line;
        public EdgeCollider2D collide;
        public Material mat;
        public Texture textures;
        public Sprite sprite;
        public EdgeCollider2D other;
        public Vector3 stuffe;


        public void Draw()
        {
            ///mat = new Material((Material)Resources.Load("prefabs/LightSprite", typeof(Material)));
            mat = new Material(Shader.Find("Sprites/Default"));
            sprite = Mod.spike;
            var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
            var pixels = sprite.texture.GetPixels((int)sprite.textureRect.x,
                                                    (int)sprite.textureRect.y,
                                                    (int)sprite.textureRect.width,
                                                    (int)sprite.textureRect.height);
            croppedTexture.SetPixels(pixels);
            croppedTexture.Apply();
            mat.mainTexture = croppedTexture;
            mat.mainTextureScale = new Vector2(0.25f, 0.25f);
            mat.SetTextureScale("_MainTex", new Vector2(0.25f, 0.25f));
            currentline = new GameObject();
            currentline.layer = 9;
            line = currentline.AddComponent<LineRenderer>();

            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(currentline, "Drawing Line"));
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.generateLightingData = true;
            line.textureMode = LineTextureMode.Tile;
            line.material = mat;
            collide = currentline.AddComponent<EdgeCollider2D>();
            other = currentline.AddComponent<EdgeCollider2D>();
            other.isTrigger = true;
            currentline.AddComponent<stabbyshit>();
            mousepos.Clear();
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            mousepos.Add(Camera.main.ScreenToWorldPoint(Input.mousePosition));
            line.SetPosition(0, mousepos[0]);
            line.SetPosition(1, mousepos[1]);
            collide.points = mousepos.ToArray();
            other.points = mousepos.ToArray();
            line.sortingOrder = 9;
            debounce = true;
        }

        public void UpdateLine(Vector2 newpos)
        {
            ///line.textureMode = LineTextureMode.Tile;
            mousepos.Add(newpos);
            line.positionCount++;
            line.widthMultiplier = 1f;
            line.startWidth = 0.5f * Mod.resizemultiplier;
            line.endWidth = 0.5f * Mod.resizemultiplier;
            line.SetPosition(line.positionCount - 1, newpos);
            ///line.material = mat;
            line.sortingOrder = 9;
            collide.points = mousepos.ToArray();
            other.points = mousepos.ToArray();
        }
    }


    public class stabbyshit : MonoBehaviour  /// Used to hurt humans when they make contact with spikes. Wish I could've made it sharp, however that would require a PhysicalBehaviour.
    {
        void OnTriggerEnter2D(Collider2D col)
        {
            if (col.transform.root.gameObject.GetComponent<PersonBehaviour>())
            {
                col.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(50f);
            }
        }
    }
}